;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	This is the global equates definition.

;Zero page addresses
cnt		= $14		;1 byte OS frame counter

mpt_zp		= $00		;13 bytes, changed in interupts
intro_zp	= $80		;40 bytes used as loading bar screen memory
header_zp	= $c0		;2*$20 = $40 bytes, changed in interrupts
main_zp		= $10		;16 bytes, containing also cnt
inflate_zp	= $20		;10 bytes, shared with field_zp
field_zp	= $20		;up to $bf, changed in interrupts
split_zp	= $20		;up to $ff, $d0 bytes, cannot used together with header_zp


; Initial fader addresses
fader_start		= $2000

; Intro addresses
intro_start		= $2000
intro_loading_start	= $8B19	;not enough space at $8200-$83ff
intro_header_start	= $9600	;32 pages from $9600-$b5ff before header_sm at $b6000

; Loader and initialization addresses
loader_start		= $4000
inflate_data		= $c000	;$03 pages
mpt_sound_start_dfl	= $c300	;$0a pages
field_chr_dfl		= $cd00	;$02 pages
field_data_dfl		= $e000	;$1a
init_start		= $b800

;Shared addresses
header_sm		= $b600	;$b400-$b5ff and $b800-$b9ff contain split charsets later
