;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;	This program creates packed field textures with 2 bits per pixel resulting in 64 bytes per texture.
;	Save using "write 4000 40ff C:\jac\system\Atari800\Programming\Demos\SillyThings\field\Silly-Field-Textures.dat"

p1	= $80
x1	= $e0

textures_packed	= $4000

	org $2000

start
	mwa #textures_input p1
	
	ldy #0
loop	jsr get_byte
	and #3
	asl
	asl
	sta x1
	jsr get_byte
	and #3
	ora x1
	sta x1
	asl x1
	asl x1
	jsr get_byte
	and #3
	ora x1
	sta x1
	asl x1
	asl x1
	jsr get_byte
	and #3
	ora x1
	sta textures_packed
texture_maps_adr = *-2
	inw texture_maps_adr
	lda get_byte.byte_count
	bne loop
	inc p1+1
	lda p1+1
	cmp #>texture_input_end
	bcc loop

	.byte $02
	


;===============================================================

	.proc get_byte
	lda byte_count
	and #$f0
	sta index
	lda byte_count
	and #15
	eor #15
	ora index
	tay
	lda (p1),y
	inc byte_count
	rts

byte_count	.byte 0
index		.byte 0
	.endp
;===============================================================
;	  O     O  
;	   O   O
;	  OOOOOOO
;	 OO OOO OO 
;	OOOOOOOOOOO
;	O OOOOOOO O
;	O O     O O  
;	   OO OO
    
	.align 256

textures_input
	.byte "  33        33  "
	.byte "  33        33  "
	.byte "   33      33   "
	.byte "   33      33   "
	.byte "  333333333333  "
	.byte "  333333333333  "
	.byte " 333  3333  333 "
	.byte " 333  3333  333 "
	.byte "3333333333333333"
	.byte "3333333333333333"
	.byte "33  33333333  33"
	.byte "33  33333333  33"
	.byte "33  33    33  33"
	.byte "33  33    33  33"
	.byte " 33  33  33  33 "
	.byte "     33  33     "

	.byte "                "
	.byte "3333  333   3333"
	.byte "3333 33333 33333"
	.byte "  33 33 33 33   "
	.byte "  33 33 33 33   "
	.byte "  33 33333 33   "
	.byte "  33 33333 33   "
	.byte "  33 33 33 33 33"
	.byte "3333 33 33 33333"
	.byte "333  33 33  333 "
	.byte "                "
	.byte " 22 222 222  222"
	.byte "2   2 2 2  2 2  "
	.byte "2   2 2 2  2 222"
	.byte "2   2 2 2  2 2  "
	.byte " 22 222 222  222"

	.byte "                "
	.byte "3333  3333  3333"
	.byte "3333 333333 3333"
	.byte "33   33  33 33  "
	.byte "3333 33  33 33  "
	.byte "3333 33  33 3333"
	.byte "  33 33  33   33"
	.byte "3 33 33  33 3 33"
	.byte "3333 33  33 3333"
	.byte " 33   3333   33 "
	.byte "                "
	.byte "  222 222  222  "
	.byte " 2    2  2 2  2 "
	.byte " 2222 2  2 2  2 "
	.byte "    2 2  2 2  2 "
	.byte " 222  2  2 222  "

	.byte "                "
	.byte " 333   333  3333"
	.byte "33333 33333 3333"
	.byte "33 33 33 33   33"
	.byte "33 33 33 33  33 "
	.byte "33 33 33 33 33  "
	.byte "33 33 33 33 33  "
	.byte "33 33 33 33 33  "
	.byte "33333 33 33 3333"
	.byte " 333   333  3333"
	.byte "                "
	.byte "  222 2222 2   2"
	.byte " 2    2     2 2 "
	.byte " 2 22 2222   2  "
	.byte " 2  2 2     2 2 "
	.byte "  22  2    2   2"

texture_input_end

;===============================================================

	run start
